open Common

type pTerm = 
    PVar of string 
    | PFsym of ( string * (pTerm list))
    | PState of string
	

type pCondition = 
    PEqual of pTerm * pTerm
  | PJoinable of pTerm * pTerm
  | PNotEqual of pTerm * pTerm


type pEquation = 
    PEquation of pTerm * pTerm * pCondition list
  | PExteq of pTerm * pTerm * ((pTerm * pTerm) list)
  | PUnique of pTerm * ((pTerm * pTerm) list)
  | PAny of pTerm * pTerm * ((pTerm * pTerm) list)



type pRule = 
    Usual of pTerm * pTerm 
    | Conditionnal of pTerm * pTerm * (pCondition list)

type pAutomaton = 
    PAut of (string * (pTerm list) * (pTerm list) * ((pTerm * pTerm) list) 
	      * ((pTerm * pTerm) list) )
    | PSet of (string * (pTerm list))


type pApprox = 
    PApp of (string * (pTerm list) * (((pTerm * pTerm) * ((pTerm * pTerm) list)) list)) 
  | PSEquation of string * (pEquation list)




module PTerm=
struct
  type t=pTerm
  let compare = compare
  let equal= (=)
  let rec to_string s = 
    match s with 
	PVar(x) -> x 
      | PState(x) -> x 
      | PFsym(f,[]) -> f 
      | PFsym(f,l) -> f^"("^(to_string_list l)^")"
  and to_string_list l = 
    match l with 
	[] -> ""
      | x::[] -> (to_string x )
      | x::rem -> (to_string x)^","^(to_string_list rem)
end


let (alpha: (string*string)list ref)= ref [];;
let (varset: string list ref)= ref [];;	  
	  

