{
(* ..................................................................
    Module.......: Lexer
    Initial Date : 21 may 2007
    Last Update..: 21 may 2007
    Developer....: Yohan Boichut
    Maintenance..: Yohan Boichut and Thomas Genet
    Compiler.....: OCAML 3.09.3 
    Comments.....: Lexer for Timbuk
 .................................................................... *)

  open Parser
  exception Eof
}

rule token = parse
    [' ' '\t']*			{ token lexbuf }  (* skip blanks *)
  | '\n'          		{ incr ErrorHandler.lineCounter; token lexbuf}
  | '%' [^ '\n']* 		{ token lexbuf }  (* skip comments *)
  | "Ops"             {CONSTRUCTORS}
  | "Vars"             {VARIABLES}
  | "TRS" {TRS}
  | "Set" {SET}
  | "Patterns" {PATTERN}
  | "SubPatterns" {SUBPATTERN}
  | "Automaton" {AUTOMATON}
  |  "Transitions" {TRANSITIONS}
  |  "Prior" {PRIOR}
  |  "States" {STATES}
  |  "Final States" {FSTATES}
  |  ':'    {COLUMN}
  | "->"            		{GIVES}
  | "Approximation" {APPROX}
  | "Equations" {EQUATIONS}
  | "Rules" {RULES}
  | "DotPatterns" {DOTPAT}
  | "if" {IF}
  | "!" {NOT}
  | "equal" {EQUAL}
  | "<->" {JOIN}
  | " /\\"  {AND}
  | '[' {LB}
  | ']' {RB}
  | '(' {LP}
  | ')' {RP}
  | "=>" {IMPLIES}
  | '=' {EQU}
  | ',' {COMMA}
  | 'q'['a'-'z''A'-'Z''0'-'9']* {STATE (Lexing.lexeme lexbuf)}
  |  ['0'-'9']+ {INTEGER (Lexing.lexeme lexbuf)}
  | ['a'-'p''r'-'z''A'-'Z'] ['a'-'z''A'-'Z''0'-'9']* { ATMD (Lexing.lexeme lexbuf)}
  | '_' {SPEVAR (Lexing.lexeme lexbuf) }
  | eof            		{ L_END }
  | _   			{ CHAR (Lexing.lexeme lexbuf) }

{

}
